Program AniWemva_opers

  use sep
  use ani_dotst
  use ani_type
  use ani_parms
  use ani_exec_time
  use ani_taper
  use ani_wemva


  implicit none

  real						        :: start, finish,start1,finish1, o3,a
  integer					        :: ixs,ino,ni,ish,st,idip,n3,t3,iz,k,j,stat
  real, allocatable					:: taper(:)
  real, allocatable					:: R_image(:,:,:),scatS(:)
  real, allocatable					:: model(:,:,:), dmodel(:,:,:), refr(:,:,:)
  complex, allocatable       			     	:: recv(:,:),source(:,:),source1(:)
  real,allocatable					:: deltaI(:,:,:),deltaM(:,:,:)
  integer					        :: sh_position
  
  call sep_init()
  call sep_begin_prog()

  ! ================================================================================================
  ! Initialization 
  start=0.;finish=0.
  call aniexec_time(start)
  
  call aniparam()

  ! Model and reference model
  allocate(model(mdl%z%n,mdl%xm%n,npar))
  call sreed("mdl", model, 4*mdl%z%n*mdl%xm%n*npar)
  allocate(refr(ref%z%n, nref_max, npar))
  call sreed("ref", refr, 4*ref%z%n*nref_max*npar)

  ! Source and receiver
  allocate(source1(sou%w%n))
  call sreed("sou", source1, 8*sou%w%n)
  allocate(source(rec%h%n, sou%w%n))
  allocate(recv(rec%h%n, rec%w%n))

  ! deltaI or deltaM
  if(adj) then
     allocate(dmodel(nz,nx,npar))
     allocate(deltaM(nz,nx,npar))
     allocate(deltaI(img%z%n,img%xm%n,nsecdim))
     call sreed("deltaI", deltaI, 4*img%z%n*img%xm%n*nsecdim)
  else
     allocate(dmodel(nz,nx,npar))
     allocate(deltaI(nz,nx,nsecdim),R_image(nz,nx,nsecdim))
     call sreed("deltaM", dmodel, 4*nz*nx*npar)
  end if

  ! Taper
  allocate(taper(nx))
  call anitaper(tapertr,taper)

  call aniexec_time(finish)
  write(0,'(8x,a,f10.2,a)')' Init.phase - Total elapsed time:', (finish - start),' (sec)'

  ! ================================================================================================

  ! Dot test of the operator
  if(dot) then
     recv=0; 
     call sreed("rec", recv, 8*rec%h%n*rec%w%n)
     call anidotst_wemva(taper, recv, source, model, refr)
  else
     if(adj) then
        deltaM=0
        do ish = 1, nsh
           start=0; finish=0; source = 0.
           call aniexec_time(start)
           sh_position = ((ish-1)*dsh + osh - rec%h%o) / dx + 1
           write(0,*) "shot position=", sh_position, (ish-1)*dsh + osh
           source(sh_position,:) = conjg(source1);
           recv=0; dmodel=0
           call sreed("rec", recv, 8*rec%h%n*rec%w%n)
           recv = conjg(recv)
           call aniwemva_init(ish)
           call aniwemva(.true.,taper,recv,source,model,refr,dmodel,deltaI)
           deltaM = deltaM + dmodel
           call aniexec_time(finish)
           write(0,111) "EXTRAPOLATED WAVEFIELDS = ",ish," OUT OF ",nsh," IN ",(finish-start)/60," min"
        end do
        deltaM(:,:,1) = deltaM(:,:,1) / maxval(deltaM(:,:,1))
        deltaM(:,:,2) = deltaM(:,:,2) / maxval(deltaM(:,:,2))
        call sep_write(deltaM)
        deallocate(dmodel, deltaM, deltaI, model, taper, refr, source, recv, source1)
     else
        R_image=0
        do ish = 1, nsh
           start=0; finish=0; source = 0.
           call aniexec_time(start)
           sh_position = ((ish-1)*dsh + osh - rec%h%o) / dx + 1
           write(0,*) "shot position=", sh_position, (ish-1)*dsh + osh
           source(sh_position,:) = conjg(source1);
           recv=0; deltaI=0
           call sreed("rec", recv, 8*rec%h%n*rec%w%n)
           recv = conjg(recv)
           call aniwemva_init(ish)
           call aniwemva(.false.,taper,recv,source,model,refr,dmodel,deltaI)
           R_image= R_image + deltaI
           call aniexec_time(finish)
           write(0,111) "EXTRAPOLATED WAVEFIELDS = ",ish," OUT OF ",nsh," IN ",(finish-start)/60," min"           
        end do
        call sep_write(R_image)
        deallocate(dmodel, deltaI, model, taper, refr, source, recv, R_image, source1)
     end if
  end if
  111 format(a26,i4,a8,i4,a4,f6.2,a4)
  call sep_end_prog()
end program AniWemva_opers
       
           
