module ani_dotst

  use ani_type
  use ani_exec_time
  use ani_parms
  use ani_taper
  use ani_wemva
  use ani_image
  use ani_fftw

  implicit none

contains

!!===============================================================

  subroutine anidotst_wemva(taper,recv,source,model,refr)

    real                                :: refr(:,:,:), model(:,:,:)
    real                                :: taper(:)
    complex                             :: recv(:,:), source(:,:)
    real,allocatable                    :: data1(:,:,:), data2(:,:,:)
    real                                :: modl1(nz,nx,npar), modl2(nz,nx,npar)
    real, dimension(2)                  :: dot
    integer                             :: i, j, k

    allocate(data1(nz,nx,nsecdim), data2(nz,nx,nsecdim))

    call random_number(modl1)
    call random_number(data2)
    modl1=modl1/1000.; data2=data2/1000.

    modl2=0.; data1=0.; dot=0.

    call aniwemva_init(1)    
    call aniwemva(.false., taper, recv, source, model, refr, modl1, data1)
    write(0,*) "after forward"
    call aniwemva(.true. , taper, recv, source, model, refr, modl2, data2)

    do k=1, nz
       do j=1,nsecdim
          dot(1) = dot(1) + dot_product(data1(k,:,j), data2(k,:,j))
       end do
       do i = 1, npar
          dot(2) = dot(2) + dot_product(modl1(k,:,i), modl2(k,:,i))
       end do
    end do
    deallocate(data1,data2)

    write(0,*) "Dot test result"
    write(0,*) "===================================="
    write(0,*) dot
    write(0,*) "===================================="
    write(0,*) ""
    write(0,*) ""
    write(0,*) ""
    write(0,*) ""

  end subroutine anidotst_wemva

end module ani_dotst
