module ani_type

  public 						:: axis, dat_grid, img_grid, modl, mref
  !--------------------------------------------------
  !!.. define type for axes
  type axis 
     integer 					:: n		! total number
     real    					:: d		! spacing
     real    					:: o		! origin
     real, allocatable				:: all(:)  	! values
  end type axis

  !---------------------------------------------------
  !!.. define data grid
  type dat_grid
     type(axis) :: w, h, xd
  end type dat_grid

  !---------------------------------------------------
  !!.. define image grid
  type img_grid
     type(axis) :: z, sh, xm, ym, th
  end type img_grid

  !---------------------------------------------------
  !!.. define model grid
  !!... eps and delta have the same structure
  type modl
     type(axis) :: z, xm, ym, par
  end type modl

  !----------------------------------------------------
  !!.. define reference model grid
  !!... eps and delta have the same structure
  type mref
     type(axis) :: z, rf, par
  end type mref

end module ani_type
